#!/usr/bin/python

import os, re, os.path, string

def processfile(infile, output, replace=()):
    input = open(infile, 'r')
    match = re.compile('\{include ([^\}]*)\}')

    for line in input.readlines():
        matchobj = match.search(line)

        if matchobj != None:
            processfile(matchobj.groups(0)[0], output, replace)
        else:
            for rep in replace:
                line = string.replace(line, rep[0], rep[1])

            output.write(line)

    
if __name__ == '__main__':
    if not os.path.exists('DeployTemplates'):
        os.mkdir('DeployTemplates')
    
    for file in os.listdir('.'):
        if re.search('Java.*\.template$', file) != None:
            print 'Processing %s' % file
            output = open('DeployTemplates/%s' % file, 'w')
            processfile(file, output)
            output.close()

            print 'Processing %s -> %s' % (file, string.replace(file, 'Java', 'Objc'))
            output = open('DeployTemplates/%s' % string.replace(file, 'Java', 'Objc'), 'w')
            processfile(file, output, (('javaValueClassName', 'valueClassName'), ('javaBindingParameters', 'bindingParameters')))
            output.close()

